diff --git a/arch/mips/include/asm/inst.h b/arch/mips/include/asm/inst.h
index 6d74ba3..3ab1c6b 100644
--- a/arch/mips/include/asm/inst.h
+++ b/arch/mips/include/asm/inst.h
@@ -14,10 +14,10 @@
 #include <uapi/asm/inst.h>
 
 #if (_MIPS_SZPTR == 32)
-#define PTR_STR		".word"
+#define INST_PTR_STR		".word"
 #endif
 #if (_MIPS_SZPTR == 64)
-#define PTR_STR		".dword"
+#define INST_PTR_STR		".dword"
 #endif
 
 /* HACHACHAHCAHC ...  */
@@ -108,8 +108,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -129,8 +129,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -162,10 +162,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -190,8 +190,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -213,8 +213,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -233,8 +233,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -266,10 +266,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -311,14 +311,14 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
-		PTR_STR"\t5b, 11b\n\t"		    \
-		PTR_STR"\t6b, 11b\n\t"		    \
-		PTR_STR"\t7b, 11b\n\t"		    \
-		PTR_STR"\t8b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
+		INST_PTR_STR"\t5b, 11b\n\t"         \
+		INST_PTR_STR"\t6b, 11b\n\t"         \
+		INST_PTR_STR"\t7b, 11b\n\t"         \
+		INST_PTR_STR"\t8b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -343,8 +343,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"              \
-		PTR_STR"\t2b, 4b\n\t"              \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                        \
 		: "r" (value), "r" (addr), "i" (-EFAULT));\
@@ -364,8 +364,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                                \
 		: "r" (value), "r" (addr), "i" (-EFAULT));  \
@@ -384,8 +384,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                                \
 		: "r" (value), "r" (addr), "i" (-EFAULT));  \
@@ -413,10 +413,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (res)				    \
 		: "r" (value), "r" (addr), "i" (-EFAULT)    \
@@ -453,14 +453,14 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
-		PTR_STR"\t5b, 11b\n\t"		    \
-		PTR_STR"\t6b, 11b\n\t"		    \
-		PTR_STR"\t7b, 11b\n\t"		    \
-		PTR_STR"\t8b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
+		INST_PTR_STR"\t5b, 11b\n\t"         \
+		INST_PTR_STR"\t6b, 11b\n\t"         \
+		INST_PTR_STR"\t7b, 11b\n\t"         \
+		INST_PTR_STR"\t8b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (res)				    \
 		: "r" (value), "r" (addr), "i" (-EFAULT)    \
@@ -486,8 +486,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -507,8 +507,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -540,10 +540,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -569,8 +569,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -592,8 +592,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -612,8 +612,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=&r" (value), "=r" (res)         \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -645,10 +645,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -690,14 +690,14 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
-		PTR_STR"\t5b, 11b\n\t"		    \
-		PTR_STR"\t6b, 11b\n\t"		    \
-		PTR_STR"\t7b, 11b\n\t"		    \
-		PTR_STR"\t8b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
+		INST_PTR_STR"\t5b, 11b\n\t"         \
+		INST_PTR_STR"\t6b, 11b\n\t"         \
+		INST_PTR_STR"\t7b, 11b\n\t"         \
+		INST_PTR_STR"\t8b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (value), "=r" (res)	    \
 		: "r" (addr), "i" (-EFAULT));       \
@@ -720,8 +720,8 @@ do {                                                 \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                        \
 		: "r" (value), "r" (addr), "i" (-EFAULT));\
@@ -741,8 +741,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                                \
 		: "r" (value), "r" (addr), "i" (-EFAULT));  \
@@ -761,8 +761,8 @@ do {                                                \
 		"j\t3b\n\t"                         \
 		".previous\n\t"                     \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 4b\n\t"               \
-		PTR_STR"\t2b, 4b\n\t"               \
+		INST_PTR_STR"\t1b, 4b\n\t"          \
+		INST_PTR_STR"\t2b, 4b\n\t"          \
 		".previous"                         \
 		: "=r" (res)                                \
 		: "r" (value), "r" (addr), "i" (-EFAULT));  \
@@ -791,10 +791,10 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (res)				    \
 		: "r" (value), "r" (addr), "i" (-EFAULT)    \
@@ -831,14 +831,14 @@ do {                                                \
 		"j\t10b\n\t"			    \
 		".previous\n\t"			    \
 		".section\t__ex_table,\"a\"\n\t"    \
-		PTR_STR"\t1b, 11b\n\t"		    \
-		PTR_STR"\t2b, 11b\n\t"		    \
-		PTR_STR"\t3b, 11b\n\t"		    \
-		PTR_STR"\t4b, 11b\n\t"		    \
-		PTR_STR"\t5b, 11b\n\t"		    \
-		PTR_STR"\t6b, 11b\n\t"		    \
-		PTR_STR"\t7b, 11b\n\t"		    \
-		PTR_STR"\t8b, 11b\n\t"		    \
+		INST_PTR_STR"\t1b, 11b\n\t"         \
+		INST_PTR_STR"\t2b, 11b\n\t"         \
+		INST_PTR_STR"\t3b, 11b\n\t"         \
+		INST_PTR_STR"\t4b, 11b\n\t"         \
+		INST_PTR_STR"\t5b, 11b\n\t"         \
+		INST_PTR_STR"\t6b, 11b\n\t"         \
+		INST_PTR_STR"\t7b, 11b\n\t"         \
+		INST_PTR_STR"\t8b, 11b\n\t"         \
 		".previous"			    \
 		: "=&r" (res)				    \
 		: "r" (value), "r" (addr), "i" (-EFAULT)    \